from gi.repository import Gtk, Gio

import threading
import random, time
from gi.repository import Gtk, Gdk, GObject
import feedparser

GObject.threads_init()
Gdk.threads_init()

class FeedApp(Gtk.Application):
	def __init__(self):
		Gtk.Application.__init__(self, application_id="org.elementary.feed2",
								 flags=Gio.ApplicationFlags.FLAGS_NONE)
		self.connect("activate", self.on_activate)
		self.connect("shutdown", self.on_shutdown)
		
	def on_activate(self, data=None):
		window = Gtk.Window(type=Gtk.WindowType.TOPLEVEL)
		window.set_title("Gtk3 Python Example")
		window.set_border_width(24)
		label = Gtk.ProgressBar()
		self.progressbar = label
		spin = Gtk.Spinner()
		spin.start()
		box = Gtk.VBox()
		box.add(label)
		box.add(spin)
		window.add(box)
		window.show_all()
		self.add_window(window)
		self.thread.start()
	
	def on_shutdown(self, data=None):
		self.thread.stop()



	

class FractionSetter(threading.Thread):
	"""This class sets the fraction of the progressbar"""


	def __init__(self, app):
		threading.Thread.__init__(self)
		self.app = app

	#Thread event, stops the thread if it is set.
	stopthread = threading.Event()

	def run(self):
		"""Run method, this is the code that runs while thread is alive."""

		#Importing the progressbar widget from the global scope
		global progressbar 

		#While the stopthread event isn't setted, the thread keeps going on
		while not self.stopthread.isSet() :
			# Acquiring the gtk global mutex
			Gdk.threads_enter()
			#Setting a random value for the fraction
			self.app.progressbar.set_fraction(random.random())
			# Releasing the gtk global mutex
			Gdk.threads_leave()
			d = feedparser.parse("http://omgubuntu.co.uk/feed")

			#Delaying 100ms until the next iteration
			time.sleep(0.5)

	def stop(self):
		"""Stop method, sets the event to terminate the thread's main loop"""
		self.stopthread.set()

def main_quit(obj):
	"""main_quit function, it stops the thread and the gtk's main loop"""
	#Importing the fs object from the global scope
	global fs
	#Stopping the thread and the gtk's main loop
	fs.stop()
	Gtk.main_quit()

if __name__ == "__main__":
	app = FeedApp()
	#Creating and starting the thread
	fs = FractionSetter(app)
	app.thread = fs
	app.run(None)


